# opentl::cvprocess::ColorHistSum Class Reference

This is a shader example for computing a histogram out of partial histogram (by simply summing them, bin per bin) NOTE: Derived class from GpuStdShaders. More...

Inherits opentl::cvprocess::GpuStdShaders.

List of all members.

## Classes
struct | Param
## Public Member Functions
| ColorHistSum (Param *param=NULL)
| Constructor.
void | copyHistoFromGPU (opentl::core::cvdata::ColourHist2d &MDestination)
| Copy back the histogram from GPU.
virtual void | execute ()
| Shader execution (overrides the base class method).
opentl::cvprocess::GlFbo * | getCurrentFbo ()
| Get the current FBO (if we want to upload textures from outside, we need to bind to the current FBO!) TODO: This is hacking the class... make it with another function, for uploading/downloading the textures from outside!
Param & | params ()
| Get/Set parameters for this class.
virtual void | prepareDisplayList ()
| Fixed display list for computing the histogram in parallel, by dividing the image into blocks of fixed size.
void | setNBlocks (int nBlocks)
| Set actual number of sub-histograms to be summed up.
virtual | ~ColorHistSum ()
| Destructor.

## Detailed Description

This is a shader example for computing a histogram out of partial histogram (by simply summing them, bin per bin) NOTE: Derived class from GpuStdShaders.

Author:
  Giorgio Panin <panin@in.tum.de>

## Constructor & Destructor Documentation

opentl::cvprocess::ColorHistSum::ColorHistSum | ( | Param * | param = `NULL` | ) |

Constructor.

Parameters:

  | param | Structure of parameters for this class

virtual opentl::cvprocess::ColorHistSum::~ColorHistSum | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

void opentl::cvprocess::ColorHistSum::copyHistoFromGPU | ( | opentl::core::cvdata::ColourHist2d & | MDestination | ) |

Copy back the histogram from GPU.

Parameters:

  | MDestination | Destination histogram (the source is the GPU texture mColourHistoTexture)

virtual void opentl::cvprocess::ColorHistSum::execute | ( |  | ) | `[virtual]`

Shader execution (overrides the base class method).

Reimplemented from opentl::cvprocess::GpuStdShaders.

opentl::cvprocess::GlFbo* opentl::cvprocess::ColorHistSum::getCurrentFbo | ( |  | ) | `[inline]`

Get the current FBO (if we want to upload textures from outside, we need to bind to the current FBO!) TODO: This is hacking the class... make it with another function, for uploading/downloading the textures from outside!

Param& opentl::cvprocess::ColorHistSum::params | ( |  | ) |

Get/Set parameters for this class.

Returns:
  Reference to parameter struct

virtual void opentl::cvprocess::ColorHistSum::prepareDisplayList | ( |  | ) | `[virtual]`

Fixed display list for computing the histogram in parallel, by dividing the image into blocks of fixed size.

Reimplemented from opentl::cvprocess::GpuStdShaders.

void opentl::cvprocess::ColorHistSum::setNBlocks | ( | int | nBlocks | ) | `[inline]`

Set actual number of sub-histograms to be summed up.